#if 1 
#define HDD_TBL_BASE 0xE400
#else
#define HDD_TBL_BASE 0x6400
#endif

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>

#define NR_ENTRIES 47 

typedef	unsigned long	ulong;
typedef unsigned int	uint;
typedef unsigned short	ushort;
typedef unsigned char	uchar;

#pragma	pack(1)
typedef struct {
        uchar   res_00;
        ushort  cyl;  
        uchar   head; 
        ushort  res_01;   
        ushort  wp;
        ushort  res_02;   
        ushort  res_03;   
        uchar   res_04;   
        ushort  lz;
        uchar   spt;
} HDD_TBL;

int main(int argc, char *argv[]) {
uchar i;
int a;
FILE *fp;
HDD_TBL hdd_rec;

    if (argc < 2) {
        printf("hdb v0.7\n");
        printf("Show and edit HDD table in BIOS file\n");
        printf("Usage: hdb [file] [elem no] [cyl head wp lz spt] \n");
        exit(EINVAL);
     }

    fp = fopen(argv[1],"rb+");
    if (!fp) {
	printf("File not found!\n");
	exit(ENFILE);
    }			

    fseek(fp, HDD_TBL_BASE, SEEK_SET);

    if (argc < 3) {
    printf("\n\tType\tCyl.\tHead\tSect.\tWrite\tLand\n\t\t\t\t\tp-comp\tZone\n");
    printf("\t--------------------------------------------\n");
	for (i=0; i < NR_ENTRIES; i++) {
            fread(&hdd_rec, sizeof(HDD_TBL), 1, fp);	
	    printf("\t%2d\t%4d\t%2d\t%2d\t%5u\t%4d\n", i+1,
	        hdd_rec.cyl, hdd_rec.head, hdd_rec.spt, hdd_rec.wp, hdd_rec.lz);
        }
    } else if (argc == 3) {
	i = atoi(argv[2]); 
        if (i<1 || i>NR_ENTRIES) {
            printf("Invalid entry number!\n");
            exit(EINVAL);
        }

	printf("\n\tType\tCyl.\tHead\tSect.\tWrite\tLand\n\t\t\t\t\tp-comp\tZone\n");
	printf("\t--------------------------------------------\n");

	i--;
	fseek(fp, i*16, SEEK_CUR);
	fread(&hdd_rec, sizeof(HDD_TBL), 1, fp);	
	printf("\t%2d\t%4d\t%2d\t%2d\t%5u\t%4d\n", i+1,
	    hdd_rec.cyl, hdd_rec.head, hdd_rec.spt, hdd_rec.wp, hdd_rec.lz);

    } else if (argc == 8) { /* edit mode  hdb file entry cyl head spt wp lz */
	i = atoi(argv[2]); 
        if (i<1 || i>NR_ENTRIES) {
            printf("Invalid entry number!\n");
            exit(EINVAL);
        }
	i--;
	fseek(fp, i*sizeof(HDD_TBL), SEEK_CUR);
        hdd_rec.cyl  = atoi(argv[3]);
        hdd_rec.head = atoi(argv[4]);
        hdd_rec.spt  = atoi(argv[5]);
        hdd_rec.wp   = atoi(argv[6]);
        hdd_rec.lz   = atoi(argv[7]);
        fwrite(&hdd_rec, sizeof(HDD_TBL), 1, fp); 

    /* show tbl entry after editing */	
	fseek(fp, -16, SEEK_CUR);
	fread(&hdd_rec, sizeof(HDD_TBL), 1, fp);	

	printf("\n\tType\tCyl.\tHead\tSect.\tWrite\tLand\n\t\t\t\t\tp-comp\tZone\n");
	printf("\t--------------------------------------------\n");
	printf("\t%2d\t%4d\t%2d\t%2d\t%5u\t%4d\n", i+1,
	    hdd_rec.cyl, hdd_rec.head, hdd_rec.spt, hdd_rec.wp, hdd_rec.lz);

    } else {
        printf("Invalid cmd line!\n");
        exit(EINVAL);
    }

return 0;
}
